unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
  private
    FLabels: Array of TLabel;
    FLabelIndex: Integer;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLType, LCLIntf;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetLength(FLabels, 3);
  FLabels[0] := Label1;
  FLabels[1] := label2;
  FLabels[2] := Label3;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  if Key = VK_UP then begin
    if FLabelIndex = 0 then FLabelIndex := High(FLabels) else dec(FLabelIndex);
  end else if Key = VK_DOWN then
    FLabelIndex := (FLabelIndex + 1) mod Length(FLabels)
  else
    exit;
  Invalidate;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  R: TRect;
begin
  R := Rect(0, 0, Width, Height);
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := clDefault;
  canvas.FillRect(R);

  with FLabels[FLabelIndex] do
    R := Rect(Left, Top, Left+Width, Top+Height);
  InflateRect(R, 3, 3);
  Canvas.Brush.Style := bsClear;
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Width := 5;
  Canvas.Rectangle(R);
end;

end.

